# Official image for Hashicorp's Terraform. It uses light image which is Alpine
# based as it is much lighter.
#
# Entrypoint is also needed as image by default set `terraform` binary as an
# entrypoint.

cache:
  paths:
    - .terraform

stages:
  - lint
  - build
  - deploy.tf

#
#   terraform 
#

# template

.terraform_template: &terraform_template
  image:
    name: hashicorp/terraform:light
    entrypoint:
      - '/usr/bin/env'
      - 'PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin'
  before_script:
    - terraform --version
    - terraform init $TERRAFORMDIR
  variables:
    PLAN: buildplan.tfplan
    NAMESERVERS: transip/nameservers.txt
    TERRAFORMDIR: ./terraform

# actions

tf-validate:
  <<: *terraform_template
  stage: lint
  script:
    - terraform validate $TERRAFORMDIR

tf-plan:
  <<: *terraform_template
  stage: build
  script:
    - terraform plan -out=$PLAN $TERRAFORMDIR
  artifacts:
    name: plan
    expire_in: 5 min
    paths:
      - $PLAN

tf-apply:
  <<: *terraform_template
  stage: deploy.tf
  environment:
    name: production
  script:
    - terraform apply -input=false $PLAN
  dependencies:
    - tf-plan
  only:
    - master

tf-destroy:
  <<: *terraform_template
  stage: deploy.tf
  environment:
    name: production
  script:
    - terraform destroy -force $TERRAFORMDIR
  dependencies:
    - tf-validate
  when: manual
  only:
    - master
